#!/usr/bin/perl
# Move a virtual system to a new host

require './server-manager-lib.pl';
&ReadParse();
&error_setup($text{'smove_err'});
$server = &get_managed_server($in{'id'});
$server || &error($text{'edit_egone'});
&can_action_error($server, "move");

# Check the move
$dest = &get_managed_server($in{'dest'});
$dest || &error($text{'smove_egone'});
$cfunc = "type_".$server->{'manager'}."_can_move";
&$cfunc($server, $dest) || &error($text{'smove_emove'});

&ui_print_unbuffered_header(&server_in($server), $text{'smove_title'}, "");
&obtain_lock_server($server);
&obtain_lock_server($dest);

$dfunc = "type_".$server->{'manager'}."_desc";
$desc = &$dfunc();
$vhost = &get_parent_server($server);

if ($in{'manual'}) {
	# Just update config to reflect existing move
	print "<b>",&text('smove_doing2', $desc,
		  "<tt>$vhost->{'host'}</tt>",
		  "<tt>$dest->{'host'}</tt>"),"</b><p>\n";
	$err = &manual_move_system($server, $dest);
	if ($err) {
		print "<b>$err</b><p>\n";
		}
	else {
		print "<b>$text{'create_done'}</b><p>\n";
		}
	}
else {
	# Start it off
	print "<b>",&text('smove_doing', $desc,
		  "<tt>$vhost->{'host'}</tt>",
		  "<tt>$dest->{'host'}</tt>"),"</b><p>\n";
	$err = &move_system($server, $dest, $in{'shutdown'}, $in{'allocate'});
	if ($err) {
		print "<b>$err</b><p>\n";
		}
	else {
		print "<b>$text{'create_done'}</b><p>\n";
		}
	}
&release_lock_server($dest);
&release_lock_server($server);
&webmin_log("move", "server", $server->{'host'},
 	    'cmd' => $dest->{'host'});
if (defined(&theme_post_save_server)) {
	&theme_post_save_server($server);
	}

&ui_print_footer("edit_serv.cgi?id=$in{'id'}", $text{'edit_return'});
