#!/usr/bin/perl
# Show a form for moving a virtual system

require './server-manager-lib.pl';
&ReadParse();
$server = &get_managed_server($in{'id'});
$server || &error($text{'edit_egone'});
&can_action_error($server, "move");

&ui_print_header(&server_in($server), $text{'smove_title'}, "", "smove");

# Check if there is anywhere to move to
$dfunc = "type_".$server->{'manager'}."_desc";
$desc = &$dfunc();
$vhost = &get_parent_server($server);
$cfunc = "type_".$server->{'manager'}."_can_move";
@dests = grep { $_->{'id'} ne $vhost->{'id'} &&
		&indexof($server->{'manager'}, &is_parent_server($_)) >= 0 &&
		&$cfunc($server, $_) }
	      &list_managed_servers();
if (!@dests) {
	&ui_print_endpage(&text('smove_nowhere', "<tt>$vhost->{'host'}</tt>",
				$desc));
	}

print $text{'smove_desc'},"<p>\n";

print &ui_form_start("move.cgi", "post");
print &ui_hidden("id", $in{'id'});
print &ui_table_start($text{'smove_header'}, undef, 2);

# System type
print &ui_table_row($text{'mkimage_type'}, $desc);

# Current host system
print &ui_table_row($text{'smove_host'}, "<tt>$vhost->{'host'}</tt>");

# Resources used
$dfunc = "type_".$server->{'manager'}."_get_disk_size";
if (defined(&$dfunc) && ($dsize = &$dfunc($server))) {
	print &ui_table_row($text{'smove_disksize'}, &nice_size($dsize));
	}
$mfunc = "type_".$server->{'manager'}."_get_memory_size";
if (defined(&$mfunc) && ($msize = &$mfunc($server))) {
	print &ui_table_row($text{'smove_memorysize'},
			  $msize ? &nice_size($msize) : $text{'edit_lunlimit'});
	}

# New host system
print &ui_table_row($text{'smove_dest'},
	&ui_select("dest", undef,
	       [ map { [ $_->{'id'},
			 $_->{'host'}.
			 &host_free_desc($_, $server->{'manager'}) ] } @dests
		]));

# Force shutdown?
print &ui_table_row($text{'smove_shutdown'},
	&ui_yesno_radio("shutdown", 0));

# Re-allocate IP?
print &ui_table_row($text{'smove_allocate'},
	&ui_yesno_radio("allocate", 1));

if (&$cfunc($dests[0]) == 2) {
	# Already moved manually
	print &ui_table_row($text{'smove_manual'},
		&ui_yesno_radio("manual", 0));
	}

print &ui_table_end();
print &ui_form_end([ [ undef, $text{'smove_ok'} ] ]);

&ui_print_footer("edit_serv.cgi?id=$in{'id'}", $text{'edit_return'});

