#!/usr/bin/perl
# Create, update or delete an SSH key

require './server-manager-lib.pl';
&can_action_error(undef, "global");
&ReadParseMime();
if (!$in{'new'}) {
	($key) = grep { $_->{'id'} eq $in{'id'} } &list_ssh_keys();
	$key || &error($text{'key_egone'});
	}
&error_setup($text{'key_err'});
&error_if_cloudmin_replica();

if ($in{'delete'}) {
	# Remove this SSH key
	@servers = &list_managed_servers();
	@users = grep { $_->{'key'} eq $key->{'id'} } @servers;
	if (@users && !$in{'confirm'}) {
		# Ask first!
		&ui_print_header(undef, $text{'dkey_title'}, undef);

		print "<center>\n";
		print &ui_form_start("save_key.cgi", "form-data");
		print &ui_hidden("id", $in{'id'});
		print &ui_hidden("delete", 1);
		print &text('dkey_rusure', "<i>$key->{'desc'}</i>",
			join(", ", map { "<tt>$_->{'host'}</tt>" } @users)),
			"<p>\n";
		print $text{'dkey_rusure2'},"<p>\n";
		print &ui_form_end([ [ "confirm", $text{'dkey_ok'} ] ]);
		print "</center>\n";

		&ui_print_footer("list_keys.cgi", $text{'keys_return'});
		exit;
		}
	else {
		# Do it..
		&obtain_lock_anything();
		&delete_ssh_key($key);
		&webmin_log("delete", "key", $key->{'id'},
			    { 'desc' => $key->{'desc'} });
		}
	}
elsif ($in{'new'}) {
	# Validate and/or generate
	$in{'desc'} =~ /\S/ || &error($text{'key_edesc'});
	$key = { 'desc' => $in{'desc'},
		 'external' => 0,
		 'addnew' => $in{'addnew'} };
	if ($in{'gen'} eq 0) {
		# Generate a new key right now
		$key->{'keydata'} = &generate_ssh_key();
		}
	elsif ($in{'gen'} eq 1) {
		# In existing server-side file
		-r $in{'file'} || &error($text{'key_efile'});
		$data = &read_file_contents($in{'file'});
		&check_ssh_key_data($data) || &error($text{'key_efile2'});
		$key->{'file'} = $in{'file'};
		$key->{'external'} = 1;
		}
	elsif ($in{'gen'} eq 2) {
		# Uploaded file, to be stored by module
		&check_ssh_key_data($in{'upload'}) ||
			&error($text{'key_eupload'});
		$key->{'keydata'} = $in{'upload'};
		}
	elsif ($in{'gen'} eq 3) {
		# Pasted text
		$in{'data'} = &cleanup_key_data($in{'data'});
		&check_ssh_key_data($in{'data'}) ||
			&error($text{'key_edata'});
		$key->{'keydata'} = $in{'data'};
		}
	elsif ($in{'gen'} =~ /^(\S+)_(\d+)/) {
		# Key generated by some server type
		$type = $1;
		$sfunc = "type_${type}_ssh_key_save";
		&$sfunc($key, $in{'gen'}, \%in);
		}
	&obtain_lock_anything();
	&save_ssh_key($key);
	&webmin_log("create", "key", $key->{'id'},
		    { 'desc' => $key->{'desc'} });
	}
else {
	# Update
	$in{'desc'} =~ /\S/ || &error($text{'key_edesc'});
	$key->{'desc'} = $in{'desc'};
	$key->{'addnew'} = $in{'addnew'};
	if ($key->{'external'}) {
		# Change file
		-r $in{'file'} || &error($text{'key_efile'});
		$data = &read_file_contents($in{'file'});
		&check_ssh_key_data($data) || &error($text{'key_efile2'});
		$key->{'file'} = $in{'file'};
		}
	elsif (defined($in{'data'})) {
		# Update key data
		$in{'data'} = &cleanup_key_data($in{'data'});
		&check_ssh_key_data($in{'data'}) ||
			&error($text{'key_edata'});
		$key->{'keydata'} = $in{'data'};
		}
	&obtain_lock_anything();
	&save_ssh_key($key);
	&webmin_log("modify", "key", $key->{'id'},
		    { 'desc' => $key->{'desc'} });
	}
&redirect("list_keys.cgi");

