#!/usr/bin/perl
# Show an applet for VNC access to a Xen system's console

require './server-manager-lib.pl';
use Socket;
&ReadParse();
$server = &get_managed_server($in{'id'});
$server || &error($text{'edit_egone'});
&can_action_error($server, "console");
$server->{'xen_vnc_display'} || $config{'xen_vnc'} ||
	&error($text{'vnc_ecannot'});
$server->{'status'} ne 'down' && $server->{'status'} ne 'nohost' ||
	&error($text{'vnc_edown'});
$server->{'manager'} eq 'xen' || &error($text{'vnc_exen'});

&ui_print_header(&server_in($server), $text{'vnc_title'}, "");

# Check and setup VNC access
$vhost = &type_xen_parent($server);
$activeport = &get_active_vnc_port($server);
if (!$server->{'xen_vnc_display'} && !$server->{'xen_vnc_unused'}) {
	# Not setup yet .. need to add perhaps
	$conf = &get_xen_config($server, 1);
	$vnclisten = &xen_find_value("vnclisten", $conf);
	$vnc = &xen_find_value("vnc", $conf);
	$vncunused = &xen_find_value("vncunused", $conf);
	$vncdisplay = &xen_find_value("vncdisplay", $conf);
	$vncpasswd = &xen_find_value("vncpasswd", $conf);
	$listenok = &to_ipaddress($vnclisten) eq
		    &to_ipaddress($vhost->{'host'}) || $vnclisten eq "0.0.0.0";
	if ($listenok && ($vnc == 1 || $vnc eq '') && $vncdisplay) {
		# Already setup on a static port .. just record it
		$server->{'xen_vnc_display'} = $vncdisplay;
		$server->{'xen_vnc_passwd'} = $vncpasswd;
		&save_managed_server($server);
		}
	elsif ($listenok && $vnc && $vncunused && $activeport) {
		# Already setup on a dynamic port
		$server->{'xen_vnc_passwd'} = $vncpasswd;
		$server->{'xen_vnc_unused'} = 1;
		$port = $activeport;
		}
	else {
		# Setup needed .. probably have to reboot
		&$first_print($text{'create_xenvnc'});
		$err = &setup_xen_vnc_console($server);
		if ($err) {
			&$second_print(&text('create_xenvncfailed', $err));
			}
		else {
			&$second_print(&text('create_xenvncdone',
					     $server->{'xen_vnc_display'}));
			print &ui_form_start("save_serv.cgi");
			print &ui_hidden("id", $in{'id'});
			print &ui_hidden("reboot", 1);
			print &ui_hidden("confirm", 1);
			print "<b>$text{'vnc_needreboot'}</b><p>\n";
			print &ui_form_end(
				[ [ undef, $text{'limits_reboot'} ] ]);
			}
		&save_managed_server($server);
		goto ENDPAGE;
		}
	}

# Check that the VNC port is really open on the Xen host, and connect to it
$port = $activeport || 5900 + $server->{'xen_vnc_display'};
$err = undef;
&open_socket($vhost->{'ip'}, $port, VNCSOCK, \$err);
if ($err) {
	print &text('vnc_nolisten', $port, $vhost->{'host'}),"<p>\n";
	goto ENDPAGE;
	}

if ($vhost->{'id'} == 0) {
	# Special case - this box is the Xen host, so no forwarding needed
	$masterport = $port;
	close(VNCSOCK);
	}
else {
	# Pick a free port on the Cloudmin master, 5900+
	$masterport = 5900;
	$proto = getprotobyname('tcp');
	socket(VNCMASTER, PF_INET, SOCK_STREAM, $proto) ||
		&error("Socket failed : $!");
	setsockopt(VNCMASTER, SOL_SOCKET, SO_REUSEADDR, pack("l", 1));
	while(1) {
		last if (bind(VNCMASTER, sockaddr_in($masterport, INADDR_ANY)));
		$masterport++;
		}
	listen(VNCMASTER, SOMAXCONN);

	# Fork a listening process to forward VNC traffic
	if (!fork()) {
		# Wait for a connection
		untie(*STDIN); untie(*STDOUT); untie(*STDERR);
		close(STDIN); close(STDOUT); close(STDERR);
		$SIG{'ALRM'} = sub { exit(2) };
		alarm(30);
		$acptaddr = accept(VNCCLIENT, VNCMASTER);
		$acptaddr || exit(1);
		close(VNCMASTER);
		alarm(0);

		# Start forwarding traffic
		select(VNCCLIENT); $| = 1;
		select(VNCSOCK); $| = 1;
		&forward_connection_sockets(VNCCLIENT, VNCCLIENT,
					    VNCSOCK, VNCSOCK);
		exit;
		}
	close(VNCMASTER);
	close(VNCSOCK);
	}

# Ouput applet HTML
print "<applet archive=vncviewer.jar code=VncViewer.class ",
      "width=100% height=620>\n";
print "<param name=port value='$masterport'>\n";
print "<param name=password value='$server->{'xen_vnc_passwd'}'>\n";
print "$text{'vnc_nojava'} <p>\n";
print "</applet>\n";

ENDPAGE:
&ui_print_footer("edit_serv.cgi?id=$in{'id'}", $text{'edit_return'});

