#!/usr/bin/perl
# Opens a window for selecting a running linux Xen instance

$trust_unknown_referers = 1;
require './server-manager-lib.pl';
&ReadParse();
&can_add_server_error("xen");
&popup_header($text{'xchooser_title'});

# Get the server, and it's instances
$vhost = &get_managed_server_by("id", $in{'host'});
$instances = &list_xen_instances($vhost);

# Selector javascript
print <<EOF;
<script>
function select(instance)
{
top.opener.ifield.value = instance;
top.close();
}
</script>
EOF

if (!ref($instances)) {
	print "<b>",&text('xchooser_elist', $instances),"</b><p>\n";
	}
elsif (!@$instances) {
	print "<b>",$text{'xchooser_enone'},"</b><p>\n";
	}
else {
	print &ui_columns_start([ $text{'xchooser_name'},
				  $text{'xchooser_id'},
				  $text{'xchooser_mem'},
				  $text{'xchooser_status'},
				  $text{'ichooser_state'} ], 100);
	@servers = &list_managed_servers();
	foreach my $i (@$instances) {
		($s) = grep { $_->{'xen'} eq $i->{'instance'} } @servers;
		print &ui_columns_row([
		    $s ? $i->{'instance'} :
			"<a href='' onClick='select(\"$i->{'instance'}\")'>".
			"$i->{'instance'}</a>",
		    $i->{'id'},
		    &nice_size($i->{'mem'}),
		    $text{'xen_state_'.$i->{'state'}} || uc($i->{'state'}),
		    $s ? &text('ichooser_unuse', $s->{'host'})
		       : $text{'ichooser_free'}
		    ]);
		}
	print &ui_columns_end();
	}

&popup_footer();

